<?php

//******************************************************************************************************
//   ATTENTION: THIS FILE HEADER MUST REMAIN INTACT. DO NOT DELETE OR MODIFY THIS FILE HEADER.
//
//   Name: ubr_file_upload.php
//   Revision: 1.9
//   Date: 8:44 PM Saturday, June 21, 2008
//   Link: http://uber-uploader.sourceforge.net
//   Initial Developer: Peter Schmandra  http://www.webdice.org
//   Description: Select and submit upload files.
//
//   Licence:
//   The contents of this file are subject to the Mozilla Public
//   License Version 1.1 (the "License"); you may not use this file
//   except in compliance with the License. You may obtain a copy of
//   the License at http://www.mozilla.org/MPL/
//
//   Software distributed under the License is distributed on an "AS
//   IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
//   implied. See the License for the specific language governing
//   rights and limitations under the License.
//
//***************************************************************************************************************

$THIS_VERSION = '1.9';

require 'ubr_ini.php';
require 'ubr_lib.php';

if($PHP_ERROR_REPORTING){ error_reporting(E_ALL); }

header('Content-type: text/html; charset=UTF-8');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: ' . date('r'));
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', FALSE);
header('Pragma: no-cache');

//Set config file
if($MULTI_CONFIGS_ENABLED){
	// Put your multi config file code here
	// eg.   if($_SESSION['user_name'] == 'TOM'){ $config_file = 'tom_config.php'; }
	// eg.   if($_COOKIE['user_name'] == 'TOM'){ $config_file = 'tom_config.php'; }
	$config_file = 'ubr_default_config.php';
}
else{ $config_file = $DEFAULT_CONFIG; }

// Load config file
require $config_file;

//***************************************************************************************************************
// The following possible query string formats are assumed
//
// 1. No query string
// 2. ?about=1
//***************************************************************************************************************
if($DEBUG_PHP){ phpinfo(); exit(); }
elseif($DEBUG_CONFIG){ debug($_CONFIG['config_file_name'], $_CONFIG); exit(); }
elseif(isset($_GET['about']) && $_GET['about'] == 1){
	kak("<u><b>UBER UPLOADER FILE UPLOAD</b></u><br />UBER UPLOADER VERSION =  <b>" . $UBER_VERSION . "</b><br />UBR_FILE_UPLOAD = <b>" . $THIS_VERSION . "</b><br />\n", 1, __LINE__);
}
$page = "main";

require 'includes/configs.inc.php';;
require 'templates/header.tpl.php';
?>

<br />

  <div align="center">
    <br />
		<p><a href="index.php">File Upload</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href="remote.php">Remote URL Upload</a></p>
    <?php if($DEBUG_AJAX){ print "<br /><div class=\"debug\" id=\"ubr_debug\"><b>AJAX DEBUG WINDOW</b><br /></div><br />\n"; } ?>

    <!-- Start Progress Bar -->
    <div class="alert" id="ubr_alert"></div>
    <div id="progress_bar" style="display:none">
      <div class="bar1" id="upload_status_wrap">
        <div class="bar2" id="upload_status"></div>
      </div>

      <?php if($_CONFIG['show_percent_complete'] || $_CONFIG['show_files_uploaded'] || $_CONFIG['show_current_position'] || $_CONFIG['show_elapsed_time'] || $_CONFIG['show_est_time_left'] || $_CONFIG['show_est_speed']){ ?>
      <br />
      <table class="data" cellpadding='3' cellspacing='1'>
        <?php if($_CONFIG['show_percent_complete']){ ?>
        <tr>
          <td align="left"><b>Percent Complete:</b></td>
          <td align="center"><span id="percent">0%</span></td>
        </tr>
        <?php } ?>
        <?php if($_CONFIG['show_files_uploaded']){ ?>
        <tr>
          <td><b>Files Uploaded:</b></td>
          <td align="center"><span id="uploaded_files">0</span> of <span id="total_uploads"></span></td>
        </tr>
        <?php } ?>
        <?php if($_CONFIG['show_current_position']){ ?>
        <tr>
          <td align="left"><b>Current Position:</b></td>
          <td align="center"><span id="current">0</span> / <span id="total_kbytes"></span> KBytes</td>
        </tr>
        <?php } ?>
        <?php if($_CONFIG['show_elapsed_time']){ ?>
        <tr>
          <td align="left"><b>Elapsed Time:</b></td>
          <td align="center"><span id="time">0</span></td>
        </tr>
        <?php } ?>
        <?php if($_CONFIG['show_est_time_left']){ ?>
        <tr>
          <td align="left"><b>Est Time Left:</b></td>
          <td align="center"><span id="remain">0</span></td>
        </tr>
        <?php } ?>
        <?php if($_CONFIG['show_est_speed']){ ?>
        <tr>
          <td align="left"><b>Est Speed:</b></td>
          <td align="center"><span id="speed">0</span> KB/s.</td>
        </tr>
        <?php } ?>
      </table>
      <?php } ?>
    </div>
    <!-- End Progress Bar -->

    <?php if($_CONFIG['embedded_upload_results'] || $_CONFIG['opera_browser'] || $_CONFIG['safari_browser']){ ?>
    <div id="upload_div" style="display:none;"><iframe name="upload_iframe" frameborder="0" width="800" height="200" scrolling="auto"></iframe></div>
    <?php } ?>

    <br />
    <form name="form_upload" id="form_upload" <?php if($_CONFIG['embedded_upload_results'] || $_CONFIG['opera_browser'] || $_CONFIG['safari_browser']){ print "target=\"upload_iframe\""; } ?> method="post" enctype="multipart/form-data"  action="#" style="margin: 0px; padding: 0px;">
<noscript><font color='red'>Warning: </font>Javascript must be enabled to use this uploader.<br /><br /></noscript>
<input class="file_1" type="file" name="upfile_0"  <?php if($_CONFIG['multi_upload_slots']){ ?>onChange="addUploadSlot(1)"<?php } ?>  onkeypress="return handleKey(event)" value="" />
<br /><br /><a href="javascript:animatedcollapse.toggle('mail')">Enter Email</a>
<div id="mail" class="mail" style="display:none;"><br /><input type="text" name="mail" size="30" style="background: url('images/urlbox.gif') no-repeat;border: none;width: 434px;height: 30px;padding-left:40px;font-size: 18px;" value=""></div>
  <br />
</form>
<script type='text/javascript'>
$("input[type=file]").filestyle({ 
    image: "browse.png",
    imageheight : 40,
    imagewidth : 90,
    width : 434
});
</script>
<br />
         <input type="image" src="/images/resetbtn.gif" id="reset_button" name="reset_button" value="Reset" onclick="resetForm();" />&nbsp;&nbsp;&nbsp;<input type="image" src="/images/uploadbtn.gif" id="upload_button" name="upload_button" value="Upload" onclick="linkUpload();" />

    <!-- End Upload Form -->
    <br /><br />

  </div>
  <div id='ajax_div'><!-- Used to store AJAX --></div>



<?php require 'templates/footer.tpl.php'; ?>